import { Nullable, uint } from "./types";
import { TSFusionEnumeration } from "./tsfusionnode";
import { TSObject } from "./tsobject";
export declare function $mapset<T, U = T>(set: Nullable<Set<T>>, mapFunction: (element: T) => Nullable<U>): Set<U>;
export declare function $mapmap<K, V, U = V>(map: Nullable<Map<K, V>>, mapFunction: (key: K, value: V) => Nullable<U>): Map<K, U>;
export declare function $conditionalClearSet<T>(set: Nullable<Set<T>>, clearFunction: (element: T) => boolean): uint;
export declare function $conditionalClearMap<K, V>(map: Nullable<Map<K, V>>, clearFunction: (element: K, value: V) => boolean): uint;
declare global {
    export interface Set<T> extends TSObject, TSFusionEnumeration {
        conditionalClear: (this: Set<T>, clearFunction: (element: T) => boolean) => uint;
        map: (this: Set<T>, mapFunction: (element: T) => any) => Set<any>;
        keysArray: (this: Set<T>) => T[];
        valuesArray: (this: Set<T>) => T[];
    }
    export interface Map<K, V> extends TSObject, TSFusionEnumeration {
        conditionalClear: (this: Map<K, V>, clearFunction: (key: K, value: V) => boolean) => uint;
        map: (this: Map<K, V>, mapFunction: (key: K, value: V) => any) => Map<K, any>;
        keysArray: (this: Map<K, V>) => K[];
        valuesArray: (this: Map<K, V>) => V[];
    }
}
